<?

$SpeechInputID = 59626 /*[Status\Sprachsteuerung\AndroidReceive]*/;
$SpeechOutputID = 31363 /*[Status\Sprachsteuerung\AndroidSend]*/;

$config = array(
	array(
		'REGEX1' => 'wie spät ist es',
			'COMMAND1' => array(
	   		'REGEX' => 'wie spät ist es',
	   		'CODE' => '$result = date("H")." Uhr ".date("i");',
	   		'SAY' => 'Die aktuelle Uhrzeit ist $result'
			)
	),

	array(
    	'REGEX1' => ' Wohnzimmer ',
    	'REGEX2' => ' Licht | Lampe ',
    		'COMMAND1' => array(
      		'REGEX' => ' an | ein | einschalten ',
        		'CODE' => '
         	 	HM_WriteValueBoolean(13859, "STATE", true);
         	',
        		'SAY' => 'Ich habe im Wohnzimmer das Licht eingeschaltet'
      	),
    		'COMMAND2' => array(
      		'REGEX' => ' aus | ausschalten ',
        		'CODE' => '
         	 	$resultcode = HM_WriteValueBoolean(13859, "STATE", false);
         	',
        		'SAY' => 'Ich habe im Wohnzimmer das Licht ausgeschaltet'
      	)
   ),
	array(
    	'REGEX1' => ' Bad ',
    	'REGEX2' => ' Temperatur ',
    		'COMMAND1' => array(
      		'REGEX' => ' Status | welche ',
        		'CODE' => '
         	 	$result = GetValue(21154);
         	 	$result = number_format($result, 1, ".", "");
         	',
        		'SAY' => 'Im Bad beträgt die Temperatur $result Grad'
      	),
    		'COMMAND2' => array(
      		'REGEX' => ' setzen | einstellen ',
        		'CODE' => '
         	 	$resultcode = HM_WriteValueFloat(52815, "SET_TEMPERATURE", $numbers[0]);
         	',
        		'SAY' => 'Ich habe im Bad die Temperatur auf $numbers[0] Grad gestellt'
      	)
   ),
	array(
    	'REGEX1' => ' Alle ',
    	'REGEX2' => ' Lichter ',
    		'COMMAND1' => array(
      		'REGEX' => ' aus | ausschalten ',
        		'CODE' => '
         	 	$result = MyFunctionAllLightsOff();
          	',
        		'SAY' => '$result'
      	)
   )
);

// BEGIN der eigenen Hilfsfunktionen

function MyFunctionAllLightsOff() {
	// hier schalte ich per Script alle Lichter aus
	// und liefere einen String mit der Antwort
	return "Ich habe alle Lichter ausgeschaltet";
	
	// Falls es ein Problem gab oder ich etwas anderes sagen will
	// liefere ich in Anhängigkeit einfach einen anderen String zurück.
	return "Ich habe das Licht im Klo nicht ausgeschaltet da dort jemand sitzt";
}

// ENDE der eigenen Hilfsfunktionen


// Ab hier nichts mehr ändern.

$SpeechInput = GetValueString($SpeechInputID);
IPS_LogMessage("Sprachsteuerung", 'SpeechInput=" '.$SpeechInput.' "');

// Alle Nummern aus dem InputString ermitteln. Liefert ein Array $numbers
// mit allen gefundenen Zahlen als Float-Werte oder false.
$minusspeech = array(" Minus ", " minus ", "- ");
preg_match_all("/-?\d+(,|\.)?\d*/", str_replace($minusspeech, "-",$SpeechInput), $numbers);
if(isset($numbers[0][0])) {
	$numbers = $numbers[0];
   for ($i = 0; $i < count($numbers); $i++) {
   	$numbers[$i] = floatval(str_replace(',', '.' , $numbers[$i]));
   	IPS_LogMessage("Sprachsteuerung", '  $numbers['.$i.']='.$numbers[$i]);
	}
}else {
	$numbers = false;
  	IPS_LogMessage("Sprachsteuerung", '  $numbers=false');
}

// Alle Einträge des $config Arrays werden auf Übereinstimmung mit dem Speech-Satz geprüft
$config_count = 0;
foreach ($config as $element) {
	$config_count++;
	$check_command = true;
	$answer = "";
	IPS_LogMessage("Sprachsteuerung", 'CONFIG'.$config_count);
   // Prüfe REGEX1 - REGEXxx auf Übereinstimmung
   for ($i = 1; $i < 100; $i++) {
		@$RegEx = $element['REGEX'.$i];
      if(empty($RegEx)) {
			break; // Abbruch da REGEXx Eintrag nicht vorhanden ist
		} else {
		   if(preg_match('/'.$RegEx.'/i', ' '.$SpeechInput.' ')) {
				IPS_LogMessage("Sprachsteuerung", '  REGEX'.$i.'['.$RegEx.']=true');
			} else {
				IPS_LogMessage("Sprachsteuerung", '  REGEX'.$i.'['.$RegEx.']=false');
            // Ein REGEXx Eintrag wurde nicht gefunden. Prüfung auf COMMAND wird nicht durchgeführt
				$check_command = false;
			}
      }
	}

	if($check_command == true) {
		// Alle REGEX wurden gefunden, suche jetzt nach den COMMAND Ausdrücken
      for ($i = 1; $i < 100; $i++) {
			@$RegEx = $element['COMMAND'.$i]['REGEX'];
			if(empty($RegEx)) {
				break; // Abbruch da COMMANDx Eintrag nicht vorhanden
			} else {
				if(preg_match('/'.$RegEx.'/i', ' '.$SpeechInput.' ')) {
					IPS_LogMessage("Sprachsteuerung", '    COMMAND'.$i.' REGEX['.$RegEx.']=true');
					$code = $element['COMMAND'.$i]['CODE'];
					$say = $element['COMMAND'.$i]['SAY'];
					IPS_LogMessage("Sprachsteuerung", '      Execute CODE :'.$code);
               // Script in CODE ausführen...
               eval($code);
               // Variablen in SAY auflösen...
					eval("\$say = \"$say\";");
					IPS_LogMessage("Sprachsteuerung", '      SAY : '.$say);
					$answer = $say;
				} else {
					IPS_LogMessage("Sprachsteuerung", '    COMMAND'.$i.' REGEX['.$RegEx.']=false');
				}
         }
		}
	}
	if($answer != "") break; // Abbruch da passendes Element aus Config gefunden wurde
}
// Leerer Anwortstring bedeutet nichts passendes gefunden.
if($answer == "") $answer = 'Nein Dave, das kann ich nicht tun!';
IPS_LogMessage("Sprachsteuerung", 'SpeechOutput="'.$answer.'"');
SetValueString($SpeechOutputID, $answer);

?>
